﻿using System;
using System.Collections;
using HeuristicLab.Persistence.Interfaces;

namespace HeuristicLab.Persistence.Default.Decomposers {  

  public class DictionaryDecomposer : IDecomposer {

    public bool CanDecompose(Type type) {
      return type.GetInterface(typeof(IDictionary).FullName) != null;        
    }

    public IEnumerable DeCompose(object o) {
      IDictionary dict = (IDictionary)o;      
      foreach ( DictionaryEntry entry in dict) {
        yield return entry.Key;
        yield return entry.Value;
      }
    }

    public object Compose(IEnumerable o, Type t) {
      IDictionary dict = (IDictionary)Activator.CreateInstance(t, true);
      IEnumerator iter = o.GetEnumerator();
      while (iter.MoveNext()) {
        object key = iter.Current;
        iter.MoveNext();
        object value = iter.Current;
        dict.Add(key, value);
      }
      return dict;
    }
  }

}
